SystemOrganization addCategory: #'Sphero-Etoys'!
SystemOrganization addCategory: #'Sphero-Core'!

Player subclass: #SpheroPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Etoys'!

!SpheroPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 18:03'!
isUniClass
	^ self ~~ self officialClass! !

!SpheroPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 18:03'!
officialClass
	^ SpheroPlayer! !

!SpheroPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 18:03'!
wantsChangeSetLogging
	"Log changes for Player itself, but not for automatically-created subclasses like Player1, Player2, but *do* log it for uniclasses that have been manually renamed."

	^ (self == self officialClass or:
		[(self name beginsWith: self officialClass asString) not]) or:
			[Preferences universalTiles]! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:37'!
connect
	^ self sendMessageToCostume: #connect! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:37'!
disconnect
	^ self sendMessageToCostume: #disconnect! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:36'!
getIsConnected
	^ self sendMessageToCostume: #isConnected! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:36'!
getPortName
	^ self sendMessageToCostume: #portName! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:33'!
getSpheroColor
	^ self sendMessageToCostume: #spheroColor! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroHeading
	^ self sendMessageToCostume: #spheroHeading! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroPitch
	^ self sendMessageToCostume: #spheroPitch! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroRoll
	^ self sendMessageToCostume: #spheroRoll! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroSpeed
	^ self sendMessageToCostume: #spheroSpeed! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroYaw
	^ self sendMessageToCostume: #spheroYaw! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getStabilization
	^ self sendMessageToCostume: #spheroStabilization! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:37'!
setPortName: aSymbol 
	^ self sendMessageToCostume: #portName: with: aSymbol! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:33'!
setSpheroColor: aColor
	^ self sendMessageToCostume: #spheroColor: with: aColor! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:35'!
setSpheroHeading: aNumber
	^ self sendMessageToCostume: #spheroHeading: with: aNumber! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:35'!
setSpheroSpeed: aNumber
	^ self sendMessageToCostume: #spheroSpeed: with: aNumber! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:35'!
setStabilization: aBoolean
	^ self sendMessageToCostume: #spheroStabilization: with: aBoolean ! !

Object subclass: #Sphero
	instanceVariableNames: 'prot speed heading pitch roll yaw color stabilization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Core'!

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 15:59'!
bitsigned16: a
	^ a > ((2 raisedTo: 16) / 2)
		ifTrue: [-1 * ((2 raisedTo: 16) - a)]
		ifFalse: a! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:08'!
color
	^ color! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:10'!
color: aColor
	color := aColor.
	prot 
		sendTo: 2
		command: 16r20
		data: {(aColor red * 255) asInteger.
				(aColor green * 255) asInteger.
				(aColor blue * 255) asInteger.
				0} asByteArray! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 15:53'!
connectOnPort: portName
	prot connectOnPort: portName.
	self isConnected ifTrue: [self initializeSampling]! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 15:53'!
disconnect
	prot disconnect! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:10'!
heading
	^ heading! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:11'!
heading: value
	heading := value \\ 360.
	heading < 0 ifTrue: [heading := 360 + heading].
	self sendRollCommand! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 16:49'!
initialize
	super initialize.
	speed := heading := pitch := roll := yaw := 0.
	color := Color white.
	stabilization := true.
	prot := SpheroProtocol new
		when: #newData send: #updateData: to: self;
		yourself! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 15:56'!
initializeSampling
	prot
		sendTo: 2
		command: 16r11
		data: {0. "n1"
				16rF0. "n2"
				0. "m1"
				1. "m2"
				0. "mask1"
				7. "mask1 2"
				0. "mask1 3"
				0. "mask1 4"
				0. "packet limit"
				"0." "mask2"
				"0." "mask2 2"
				"1." "mask2 3"
				"16r80" "mask2 4"} asByteArray! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 16:24'!
isConnected
	^ prot isConnected ! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:08'!
pitch
	^ pitch! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:08'!
roll
	^ roll! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 15:58'!
sendRollCommand
	prot
		sendTo: 2 
		command: 16r30
		data: {speed.
				heading bitShift: -8.
				heading bitAnd: 255.
				1} asByteArray! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:11'!
speed
	^ speed! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:12'!
speed: value
	speed := value \\ 256.
	self sendRollCommand ! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:12'!
stabilization
	^ stabilization! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:15'!
stabilization: value
	stabilization := value.
	prot 
		sendTo: 2
		command: 16r2
		data: {value asBit} asByteArray! !

!Sphero methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 16:07'!
updateData: data
	(data at: 3) = 3
		ifTrue: [
			"Sensor(Data)"
			pitch := self bitsigned16: (((data at: 6) bitShift: 8) bitOr: (data at: 7)).
			roll := self bitsigned16: (((data at: 8) bitShift: 8) bitOr: (data at: 9)).
			yaw := self bitsigned16: (((data at: 10) bitShift: 8) bitOr: (data at: 11)).
			]! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:07'!
yaw
	^ yaw! !

Object subclass: #SpheroProtocol
	instanceVariableNames: 'port inQueue outQueue inTh outTh seq parsing state currentPacket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Core'!

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 7/31/2012 16:18'!
connectOnPort: aString
	self isConnected ifTrue: [^ self].
	port := SerialPort new baudRate: 57600.
	port := port
				openPort: (('COM*' match: aString)
						ifTrue: [aString asInteger]
						ifFalse: [aString]).
	self isConnected ifTrue: [self startProcesses]! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 7/31/2012 16:18'!
disconnect
	self isConnected ifFalse: [^ self].
	self stopProcesses.
	port close.
	port := nil.
	self initialize! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 7/31/2012 16:46'!
getCRC: packet
	"Assumes the argument is the whole packet with the space for the CRC,
	regardless of its value"
	| sum |
	sum := 0.
	3 to: packet size - 1 do: [:i | sum := sum + (packet at: i)].
	^ (sum \\ 256) bitXor: 2r11111111! !

!SpheroProtocol methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 16:31'!
initialize
	super initialize.
	inQueue := OrderedCollection new.
	outQueue := OrderedCollection new.
	state := #h1.
	parsing := false.
	seq := 0! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 7/31/2012 15:13'!
isConnected
	^ port notNil! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 7/31/2012 15:52'!
parsePacket
	parsing := true.
	[inQueue notEmpty]
		whileTrue: [| b |
			b := inQueue removeFirst.
			state caseOf: {
				[#h1] -> [b = 255
					ifTrue: [currentPacket := OrderedCollection with: b.
						state := #h2]].
				[#h2] -> [(b = 255 or: [b = 254])
					ifTrue: [currentPacket add: b.
						state := #MRSP]].
				[#MRSP] -> [currentPacket add: b.
						state := #SEQ].
				[#SEQ] -> [currentPacket add: b.
						state := #DLEN].
				[#DLEN] -> [currentPacket add: b.
						state := b = 1 ifTrue: [#CRC] ifFalse: [#DATA]].
				[#DATA] -> [currentPacket add: b.
						(currentPacket size - 5) = ((currentPacket at: 5) - 1)
							ifTrue: [state := #CRC]].
				[#CRC] -> [currentPacket add: b.
						(currentPacket last = (self getCRC: currentPacket))
							ifTrue: [self triggerEvent: #newData with: currentPacket asByteArray]
							ifFalse: [self error: 'CRC error'].
						state := #h1]
			}].
	parsing := false! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 7/31/2012 17:54'!
readInput
	self isConnected ifFalse: [^ self].
	inQueue addAllLast: port readByteArray.
	parsing ifFalse: [self parsePacket].
	10 milliSeconds asDelay wait! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 7/31/2012 15:25'!
sendTo: addr command: command data: data
	| buff |
	buff := {255.
			255.
			addr.
			command.
			seq.
			data size + 1},
			data,
			{0}.
	buff atLast: 1 put: (self getCRC: buff).
	outQueue addLast: buff asByteArray.
	seq := seq + 1.
	seq := seq \\ 256

	! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 7/31/2012 16:18'!
startProcesses
	inTh := [[self readInput] repeat] forkNamed: self asString , ' - In'.
	outTh := [[self writeOutput] repeat] forkNamed: self asString , ' - Out'.! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 7/31/2012 16:19'!
stopProcesses
	inTh ifNotNil: [:p | p terminate].
	outTh ifNotNil: [:p | p terminate].
	inTh := outTh := nil! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 7/31/2012 17:54'!
writeOutput
	self isConnected ifFalse: [^ self].
	outQueue notEmpty
		ifTrue: [port nextPutAll: outQueue removeFirst].
	10 milliSeconds asDelay wait! !

CircleMorph subclass: #SpheroMorph
	instanceVariableNames: 'sphero portName logo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Etoys'!

SpheroMorph class
	instanceVariableNames: 'lastPortName form'!

SpheroMorph class
	instanceVariableNames: 'lastPortName form'!

!SpheroMorph class methodsFor: 'viewer categories' stamp: 'Richo 7/31/2012 17:31'!
additionsToViewerCategories
^ #(

(#'sphero - connection' (
#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
#(slot portName 'Name of the OS port in which the device is connected' PEPort readWrite Player getPortName Player setPortName: )
))

(#'sphero - misc' (

#(slot #spheroColor '' Color readWrite Player getSpheroColor Player setSpheroColor:  )
#(slot #spheroHeading '' Number readWrite Player getSpheroHeading Player setSpheroHeading:  )
#(slot #spheroSpeed '' Number readWrite Player getSpheroSpeed Player setSpheroSpeed:  )
#(slot #stabilization '' Boolean readWrite Player getStabilization Player setStabilization:  )
#(slot #spheroPitch '' Number readOnly Player getSpheroPitch Player unused )
#(slot #spheroRoll '' Number readOnly Player getSpheroRoll Player unused )
#(slot #spheroYaw '' Number readOnly Player getSpheroYaw Player unused )
))

)! !

!SpheroMorph class methodsFor: 'parts bin' stamp: 'Richo 7/31/2012 17:55'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Sphero' translatedNoop
		categories: ((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation: 'An object that lets you communicate with a Sphero ball' translatedNoop! !

!SpheroMorph class methodsFor: 'form' stamp: 'Richo 7/31/2012 17:59'!
form
	^ form ifNil: [self initializeForm]! !

!SpheroMorph class methodsFor: 'form' stamp: 'Richo 7/31/2012 18:00'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG: 'iVBORw0KGgoAAAANSUhEUgAAADMAAAAxCAYAAAB3aZEhAAAABHNCSVQFBQUBSsjp7wAAAV5J
REFUeF7lmksOwjAMRHP8LHssjpQdsGEBiHimGX9CI1VVJURkvzoe223tuN1bf14Zd5f12qB/
bBj9LF1ZhFyJZRPqalIVCElJVSEkM+iEJ8cY8BVLCPQgY4BpmAshwGMKI76MciFkEPEw5M0g
GSFRTOQTmngkyhCIEJSLkolQhGBDAmNkiRB7emUaYhJi1HMFQ8w8VD1WKMWAZHrJey50CJZ3
xLHiGXt27AjzirdysE81UaysqmqE5JyM0INofcJ4HM476lMMrU8Yj8P7zLSYSz3y478lv1eS
YSpSlihORhQzTE3P1i/hMVODzPVjpuppFpxn2Jjj8oxQASCx46sAArWZtOpktJlaNcdVnCfe
8fTSedpH+5tK05igle4BsJ3MskSmnc3d+mYr3f+9OprFCGlmnglzGT2RAvMZvwmaeIYpUd0R
U2e51tpl6nzdLzdcV+QXGiHLm0jaKkLiAefrxnQjv0MqAAAAAElFTkSuQmCC'! !

!SpheroMorph class methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:47'!
lastPortName
	"
	lastPortName := nil.
	"
	^ lastPortName! !

!SpheroMorph class methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:47'!
lastPortName: aSymbol
	lastPortName := aSymbol! !

!SpheroMorph methodsFor: 'viewer category filter' stamp: 'Richo 7/31/2012 17:50'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!SpheroMorph methodsFor: 'connection' stamp: 'Richo 7/31/2012 17:45'!
connect
	[sphero connectOnPort: portName]
			on: Error
			do: [:err | self inform: err description]! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:50'!
delete
	self isConnected ifTrue: [self disconnect].
	super delete.! !

!SpheroMorph methodsFor: 'connection' stamp: 'Richo 7/31/2012 17:46'!
disconnect
	sphero disconnect! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 18:02'!
initialize
	super initialize.
	self extent: 150@150;
		color: Color white;
		borderColor: (Color r: 0.0 g: 0.548 b: 0.806);
		borderWidth: 3;
		clipSubmorphs: true;
		yourself.
	sphero := Sphero new.
	self initializePortName;
		initializeSpheroLogo! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:47'!
initializePortName
	| availablePorts |
	availablePorts := PESerialPort availablePorts.
	(availablePorts includes: self class lastPortName)
		ifFalse: [self class lastPortName: availablePorts first].
	portName := self class lastPortName! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 18:01'!
initializeSpheroLogo
	logo := (SketchMorph withForm: self class form)
		center: self center.
	self addMorphBack: logo! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:56'!
initializeToStandAlone
	self initialize! !

!SpheroMorph methodsFor: 'connection' stamp: 'Richo 7/31/2012 17:46'!
isConnected
	^ sphero isConnected! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:36'!
newPlayerInstance
	^ SpheroPlayer newUserInstance! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:46'!
portName
	^ portName! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:46'!
portName: aSymbol 
	self isConnected
		ifTrue: [self disconnect].
	portName := aSymbol = #'other...'
				ifTrue: [(FillInTheBlank request: 'Port name:' translated) asSymbol]
				ifFalse: [aSymbol].
	self class lastPortName: portName! !

!SpheroMorph methodsFor: 'fileOut' stamp: 'Richo 7/31/2012 17:50'!
prepareToBeSaved
"When saving a project be sure to disconnect the board, otherwise we will have a lot of problems"
	super prepareToBeSaved.
	self isConnected ifTrue: [self disconnect]! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroColor
	^ sphero color! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroColor: aColor
	sphero color: aColor! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroHeading
	^ sphero heading! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroHeading: aNumber
	^ sphero heading: aNumber! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroPitch
	^ sphero pitch! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroRoll
	^ sphero roll! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroSpeed
	^ sphero speed! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroSpeed: aNumber
	^ sphero speed: aNumber! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroStabilization
	^ sphero stabilization! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroStabilization: aBoolean
	^ sphero stabilization: aBoolean! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroYaw
	^ sphero yaw! !

!SpheroMorph methodsFor: 'viewer category filter' stamp: 'Richo 7/31/2012 17:51'!
validCategories
	"Returns valid categories for the Sphero object"
	^(self class additionsToViewerCategories collect: [:each| each first])! !
